#pragma once
#include "matrix.hpp"
#include "map.hpp"

namespace maze {

  void init(Matrix& maze);

  void hunt_and_kill(Matrix& maze, std::vector<Room>& rooms, std::vector<Point>& dead_ends, bool init_map=true);

  void randomize_rooms(std::vector<Room>& rooms_out, std::vector<Point> maybe_here);

  void inner_ring(Matrix& map, size_t outer_size, size_t inner_size);

  void divide(Matrix& maze, Point start, Point end);

  void remove_dead_ends(Matrix& maze, std::vector<Point>& dead_ends);
}
